; crackme 1
;
; Copyright (c) 2004 Jan Wassenberg
;
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License as
; published by the Free Software Foundation; either version 2 of the
; License, or (at your option) any later version.
;
; This program is distributed in the hope that it will be useful, but
; WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
; General Public License for more details.
;
; Contact info:
;   Jan.Wassenberg@stud.uni-karlsruhe.de
;   http://www.stud.uni-karlsruhe.de/~urkt/


bits 32
org 0x400000

; setting checksum:
; 1) build with STOP_AT_CHECKSUM defined.
;    ofs := dx value at crash
; 2) build with set 2nd CHECKSUM define to 256-ofs, STOP_AT_CHECKSUM undefined

;%define STOP_AT_CHECKSUM
;%define DISABLE_CHECKSUM

%define FINAL					; adds obfuscation (jcc)
						; want to be able to get rid of it, so we can look at disassembly

%define DELAY 0x000000ff			; wait loops at begin so we can attach debugger. sum of bytes in number = 0xff!

%ifdef STOP_AT_CHECKSUM
%define CHECKSUM 0
%else
%define CHECKSUM 256-0x7e				; choose such that byte sum of [start,end] = 0
%endif


start:


;############################################################################################################################
; header
;############################################################################################################################

%define rva(addr) (addr - 0x400000)

header:
		db	'MZ'				; e_magic
		db	'.',0				;   dropped file name
		dd	'PE'				; Signature
		dw	0x014c				; Machine = x86
		dw	1				; NumberOfSections
imp_tbl:	dd	0x80000009			;   some function from user32 (ordinal), to make sure it's loaded
start_chk:	dd	0				;   end of import list
		dd	0
		dw	0x0070				; SizeOfOptionalHeader
		dw	0x010f				; Characteristics = 32 bit exe
		dw	0x010b				; Magic
		db	'user32.dll',0			;   Name (RVA 30)
		db	0,0,0
		dd	rva(entry)			; AddressOfEntryPoint
		dd	0,0
		dd	0x400000			; ImageBase
		dd	4				; SectionAlignment, e_lfanew
		dd	4				; FileAlignment
		dd	0,0
		dw	4				; MajorSubsystemVersion
		dw	0,0,0
		dd	512				; SizeOfImage (virtual)			(was 64 KB)
		dd	0xa4				; SizeOfHeaders
		dd	0
		dw	2				; Subsystem = WIN32_GUI
		dw	0
		dd	0x400000			; SizeOfStackReserve
		dd	0x400000			; SizeOfStackCommit
		dd	30				;   Name (RVA 108)
		dd	rva(imp_tbl)			;   FirstThunk
		dd	0
		dd	2				; NumberOfRvaAndSizes (# data dirs)
		dd	0				; Export VirtualAddress
		dd	0				; Export Size, End Import
		dd	96				; Import VirtualAddress
		dd	40				; Import Size
		dd	0,0
		dd	0				; VirtualSize
		dd	0				; VirtualAddress
		dd	512				; SizeOfRawData				(was 64 KB)
		dd	0				; PointerToRawData


;############################################################################################################################
; code
;############################################################################################################################


%define DLL_NAME_KEY     0x3755a3f1
%define DLL_BASE_KEY     0x3847a96e			; MSB clear -> encoded DLL addr > 0 (used in checksum code)
%define FUNC_NAME_KEY    0x55aaaa55
%define FUNC_ADDR_KEY    0x63d4924c
%define TEXT_CODE_KEY    0x49f37100			; hidden data + 1 byte opcode in front
%define TEXT_KEY         0x0049f371			; only data (shifted 1 byte right to skip opcode)


;_______________________________________________________;
;
; > ebx -> DLL ^ DLL_BASE_KEY (crash+burn if invalid)
; > edx = function name [8:5] ^ FUNC_NAME_KEY
; < eax -> function address ^ FUNC_ADDR_KEY
; < ebx -> DLL
; < flags: positive addition
; x ecx edx esi edi
;_______________________________________________________;
;
get_proc_address:

	; twiddle params around and zero edi
	xchg		eax, edx			; eax = name, edx = org eax
	cdq						; name is ASCII (< 0x80) => edx = 0
	xchg		eax, edx			; eax = 0, edx = name
	xor		edx, FUNC_NAME_KEY		; decrypt name
	xchg		eax, edi			; eax = org edi, edi = 0
	xor		ebx, DLL_BASE_KEY
	xchg		eax, ecx			; NOP (eax = org ecx, ecx = org edi)

	; esi -> export dir
	mov		eax, [ebx+0x3c]			; PE header RVA
	mov		esi, [ebx+eax+0x78]		; export dir RVA
	add		esi, ebx			; -> export dir

	; scan name table; overrun if not found. put index in edi
	add		esi, byte 0x20
	lodsd						; import name array RVA (exp_dir+0x20)
find_name_loop:
	mov		ecx, [ebx+eax]			; import name RVA
	inc		edi
	add		eax, byte 4
	cmp		[ebx+ecx+5], edx		; compare second dword of name
	jne		find_name_loop
	cdq						; hide no longer needed edx

	; convert index to ordinal
	lodsd						; ordinal table RVA (exp_dir+0x24)
	add		eax, ebx
	movzx		edx, word [eax+edi*2-2]		; ordinal
	add		edx, [esi-0x28+0x10]		; re-based ordinal + 1 (exp_dir+0x10)

	; return functions[ordinal]
	mov		eax, [esi-0x28+0x1c]		; function table RVA (exp_dir+0x1c)
	add		eax, ebx
	mov		eax, [eax + edx*4 - 4]		; function
	add		eax, ebx

	xor		eax, FUNC_ADDR_KEY

	ret


;_______________________________________________________;
;
; entry point
;_______________________________________________________;
;
entry:
%ifdef FINAL
	call		a1
		db	0xb8				; mov eax - messes up disassembly
a1:
%endif
	mov		ecx, DELAY
	loop		$

	; get module list
	; < esi = &TickCount / 4
fs	mov		eax, [ecx+0x30]			; eax -> PEB
	cdq						; on NT systems, < 0x80000000 => edx = 0
	mov		esi, 0x7ffe0000 / 4		; &TickCount / 4
	mov		eax, [eax+0x0c]			; eax -> PEB_LDR_DATA
%ifdef FINAL
	pop		ebp				; start address, but we don't do anything with it!
%endif
	push		dword [eax+0x1c]		; TOS -> InInitializationOrderModuleList LIST_ENTRY

	; calculate image base (it's always 0x400000, but mask our intent)
	; < ebp = image base / 8
	mov		eax, [header+0x54]		; sizeof image = 512
	shl		eax, 10				; = image base (0x400000) / 8
	xchg		eax, ebp

	; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ ;
	; mess up image base if whole-exe checksum fails
	; >> esi
	cdq						; edx = 0
	push		esi
	mov		ecx, rva(end)-rva(start_chk)	; program size (bytes)
	lea		esi, [ebp*8 + edx + rva(start_chk)]	; load address (= start); edx for smaller encoding
.1:	lodsb
	add		dl, al
	loop		.1
	movzx		edx, dl				; discard overflows; 0 if good
	pop		esi
%ifdef STOP_AT_CHECKSUM
	ud2
%else
	nop
	nop
%endif
%ifdef DISABLE_CHECKSUM
	cdq
%endif
	dec		edx				; -1 if good, crap if not
	and		ebp, edx			; leave ebx intact iff good

	; get start time (to detect debugger)
	; > esi = &TickCount / 4
	; < ebx = start tick count
	inc		edx
	mov		eax, [esi*4+edx]		; edx for smaller encoding
.2:	mov		ebx, [esi*4+edx]
	cmp		eax, ebx			; changed, i.e. start of next tick?
	je		.2				; no - again
	neg		ebx				; subtracted later

	; prepare stack frame for MessageBox call
	; (push / call is too obvious)
	; > ecx = 0
	pop		edx				; edx -> module list
	push		byte 20
	pop		eax
	xchg		eax, ecx			; eax = 0, ecx = 20
	sub		esp, byte 20
%ifdef FINAL
	js		n1				; NOP
%endif
	mov		edi, esp
	mov		al, 0xff
	salc						; al = 0
rep	stosb
n1:
	xchg		edx, edi			; edi -> module list

	; setup call and return address for find_dll
	; ebp = load address / 8
	lea		eax, [ebp*8+rva(find_dll_ret)]	; return address for 'call' to find_dll
	cdq						; edx = 0
	push		eax

	; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ ;
	; mess up module list addr if more than 10 ms elapsed (anti-debug)
	add		ebx, [esi*4+edx]		; elapsed time, in 10 ms ticks; edx for smaller encoding
	lea		eax, [ebx+1]
	xchg		eax, edi			; eax -> module list
	cdq						; edx = 0 so we don't overflow (dividing by 1 or 2..n)
	div		edi				; div by 1 (=> eax unchanged) iff < 10 ms elapsed
	xchg		eax, esi

	; +++++++++++++++++++++++++++++++++++++++++++++ ;
	; call find_dll (to get user32 DLL load address)
	; > edx = 0
	; > esi -> module list
	; < ebx -> DLL ^ DLL_BASE_KEY
	lea		ebx, [ebp*8+rva(find_dll)]	; -> find_dll
	xor		edx, 'ER32' ^ DLL_NAME_KEY	; user32 filename for find_dll
	jns		a2
		db	0x35				; xor eax - messes up disassembly
a2:
	jmp		ebx				; find_dll
	nop						; padding up to 512

find_dll_ret:
%ifdef FINAL
	jz		n3				; NOP
%endif

	; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ ;
	; mess up DLL base ptr in ebx if whole-exe checksum fails
	cdq						; edx = 0 since DLL_BASE_KEY MSB clear
	mov		ecx, rva(end)-rva(start_chk)	; program size (bytes)
	lea		esi, [ebp*8 + edx + rva(start_chk)]	; load address (= start); edx for smaller encoding
.1:	lodsb
	add		dl, al
	loop		.1
	movzx		edx, dl				; discard overflows; 0 if good
%ifdef DISABLE_CHECKSUM
	cdq
%endif
	or		ebx, edx			; leave ebx intact iff good
	dec		edx				; -1 if good, crap if not

%ifdef FINAL
	jz		n2				; NOP
%endif
	xor		edx, 'geBo' ^ FUNC_NAME_KEY ^ -1
n2:

	; +++++++++++++++++++++++++++++++++++++++++++++ ;
	; call get_proc_address (for MessageBox)
	; > ebx = encoded DLL base ptr
	; > edx = encoded func name
	jmp		a3
		dd	0x214f4e05 ^ TEXT_CODE_KEY	; add eax opcode, "NO" (zero terminated) message
msg		equ	$-3
		db	0				; finish add eax instruction, zero-terminate msg
		db	0x35				; xor eax opcode - messes up disassembly

%ifdef STOP_AT_CHECKSUM
		db	(CHECKSUM + 0xe6) & 0xff
%else
		db	(CHECKSUM + 0xe0) & 0xff
%endif

a3:

	call		get_proc_address		; user32, MessageBox
n3:

	; build string and call MessageBox
	; > eax = proc address
	; > ebx = DLL base = 0x????0000
	xchg		eax, ebx			; eax = DLL base, ebx = proc address ^ FUNC_ADDR_KEY
	bswap		eax
	mov		ax, 0x4000
	bswap		eax				; eax = 0x400000 -> module base
	xor		ebx, FUNC_ADDR_KEY
	mov		eax, [eax+rva(msg)]
	xor		eax, TEXT_KEY
	lea		edi, [esp+16]
	mov		[esp+4], edi
	stosd
	call		ebx				; MessageBox

	pop		eax				; cleanup MessageBox stack frame
	ret



;_______________________________________________________;
;
; > edx = dll name[5:2] ^ DLL_NAME_KEY
; > esi -> first LIST_ENTRY of module list
; < ebx -> DLL ^ DLL_BASE_KEY
; < flags: !ZF
; x eax, edx
;_______________________________________________________;
;
find_dll:

	xor		edx, DLL_NAME_KEY

find_dll_loop:
	; get next list entry
	lodsd
	mov		ebx, [eax+8]			; module load address
	xchg		eax, esi

	; compare module export name
	mov		eax, [ebx+0x3c]			; PE header RVA
	mov		eax, [ebx+eax+0x78]		; export dir RVA
	mov		eax, [ebx+eax+12]		; name RVA
	cmp		[ebx+eax+2], edx		; compare chars [5:2]
	jne		find_dll_loop
	cdq						; hide no longer needed edx

	xor		ebx, DLL_BASE_KEY

	ret


end: